#!/usr/bin/perl -wT
##########################################################
### Systemwalker Portal CGI
###   Link CGI between Systemwalker and Portalworks
###
### All Rights Reserved, Copyright(C) ٻ̳ 2005
##########################################################

###################################################
### Flag switch
###   0: OFF
###   1: ON
####################################################
$testFlag = 0;
$debugFlag = 0;

####################################################
### Initialize CGI
####################################################
use CGI;
use CGI::Carp;
use Fcntl;
$query = new CGI;
umask(0177);
my $error = 0;
my @Pattern = ();

####################################################
### Path Settings
####################################################
my $basedir = "/opt/swptl/conf";
my $swptldata = "$basedir/swptldata";
my $omgrport = "$basedir/omgrport";
my $hostlist = "$basedir/hostlist";
my $lockfile = "$basedir/swptllock";
my $portalworks = "http://portalserver/portalworks/director/";

####################################################
### Event Patterns
####################################################
$Pattern[0] = "did not start at scheduled time.";
$Pattern[1] = "did not finish before Estimated end time.";
###$Pattern[x] = "[MESSAGES]";


##########################################################
###
### Main
###
##########################################################

####################################################
### HTML Header
####################################################
print "Content-type: text/html\n\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<META HTTP-EQUIV=Content-Type CONTENT=text/html; charset=euc-jp>\n";
print "<META HTTP-EQUIV=Content-Style-Type CONTENT=text/css>\n";
print "<META HTTP-EQUIV=Pragma CONTENT=no-cache>\n";
print "<META HTTP-EQUIV=Cache-Control CONTENT=no-cache>\n";
print "<META HTTP-EQUIV=Expires CONTENT=-1>\n";
print "<TITLE>Systemwalker Portal Link Page</TITLE>\n";

####################################################
### Get Post Data
####################################################
my $event = $query->param("EVENTTEXT");
my $host = $query->param("HOST");
my $ip = $query->param("IP");
my $subsys = ""; 
my $subport = ""; 
my $project = ""; 

####################################################
### Check Data
####################################################
$error += &CheckData($swptldata, "FILE");
$error += &CheckData($omgrport, "FILE");
$error += &CheckData($hostlist, "FILE");
$error += &CheckData($lockfile, "FILE");
$error += &CheckData($portalworks, "URL");
$error += &CheckData($host, "HOST");
$error += &CheckData($ip, "IP");

####################################################
### Check Event Data
####################################################
if(! $error){
  my @results = &CheckEvent($event, @Pattern);
  if(length($results[0]) && length($results[1])){
    $subsys=$results[0]; 
    $project=$results[1]; 
  }else{
    $error += 1;
  }
}else{

if($debugFlag == 1){
  print "Main::CheckEventData($error)<br>\n";
}

}

####################################################
### Get and Check Subsystem Port Number
####################################################
if(! $error){
  $subport = &GetProfileString($omgrport, "jobsch_win${subsys}", "[1-9][0-9]{0,4}");
  $error += &CheckData($subport, "PORT");
}else{

if($debugFlag == 1){
  print "Main::CheckSubsystemPortNumber($error)<br>\n";
}

}

if(! $error){
  my $ip_tmp = &GetProfileString($hostlist, $host, "[0-9.]{7,15}");
  $error += &CheckData($ip_tmp, "IP");
  if($ip_tmp eq $ip){
  }else{
    $error += 1;
    $host = "";
    $ip = "";
  }
}else{

if($debugFlag == 1){
  print "Main::CheckHostandIP($error)<br>\n";
}

}

####################################################
### Write Link Data for Portalworks
####################################################
if((-e $swptldata) && (! -l $swptldata) && (-R $swptldata) && (-W $swptldata) && (! $error)){
  ### If senced any error, can not go...
  my $lockerr = &lock($lockfile);
  if(!$lockerr){
    my $outret = sysopen OUT,$swptldata,O_WRONLY|O_TRUNC;
    if($outret eq undef){
    } else {

if($debugFlag == 1){
  print "Main::host = [$host]<br>\n";
  print "Main::ip = [$ip]<br>\n";
  print "Main::subsys = [$subsys]<br>\n";
  print "Main::subport = [$subport]<br>\n";
  print "Main::project = [$project]<br>\n";
}
      print OUT "HOST=$host\n"; 
      print OUT "IP=$ip\n"; 
      print OUT "SUBSYS=$subsys\n"; 
      print OUT "SUBPORT=$subport\n"; 
      print OUT "PROJECT=$project\n"; 
    }
    close OUT;
    &unlock($lockfile);
  }else{
    $error += 1;

if($debugFlag == 1){
  print "Main::lock($lockerr)<br>\n";
}

  }
}else{
  $error += 1;

if($debugFlag == 1){
  print "Main::WriteLinkData($error)<br>\n";
}

}

####################################################
### HTML Main
####################################################
if($error){
  ### If senced any error, can not go...
  print "<BODY>\n";
  print "<CENTER>\n";
  print "<br>Systemwalker PortalɽǤޤǤ<br>\n";
}else{
  print "<SCRIPT type=text/javascript>\n";
  print "<!--\n";
  print "function _sw_callPW(){\n";
  print "  window.open(\"$portalworks\");\n";
  print "  Window_Close();\n";
  print "  return;\n";
  print "}\n";
  print "function Window_Close(){\n";
  print "  self.close();\n";
  print "  return;\n";
  print "}\n";
  print "//-->\n";
  print "</SCRIPT>\n";
  print "</HEAD>\n";
  print "<BODY onload=_sw_callPW();>\n";
  print "<CENTER>\n";
  print "<br>ưǿɥʤϡΥ󥯤򥯥åƤ<br>\n";
  print "<br><a href=$portalworks target=_blank>Systemwalker Portal</a><br>\n";
  print "<br>ɥ顢ΥɥĤƤ<br>\n";
}

####################################################
### HTML Tail
####################################################
print "</CENTER>\n";
print "</BODY>\n";
print "</HTML>\n";


##########################################################
### 
### Sub Routines
### 
##########################################################

####################################################
### Get Profile String
###   Search the value of the key from the target file.
###
### GetProfileString($file, $key, $pattern)
###   $file    : the target file
###   $key     : the target key
###   $pattern : value pattern
###   Return value : value of the key
####################################################
sub GetProfileString {
  my $file = $_[0];
  my $key = $_[1];
  my $pattern = $_[2];
  my $value = ""; 

if($debugFlag == 1){
  print "GetProfileString::file = [$file]<br>\n";
  print "GetProfileString::key = [$key]<br>\n";
  print "GetProfileString::pattern = [$pattern]<br>\n";
}

  ### Open target file
  if((-e $file) && (! -l $file) && (-R $file)){
    my $ret = sysopen IN,$file,O_RDONLY;
    if($ret eq undef){
    } else {
      my $input = "";
      while($input = <IN>){
        my $tmp = $input;
        chomp $tmp;
        ### Search specified pattern
        if($tmp=~/^${key}\=(${pattern})$/){
          $value = $1;
        }else{
        }
      }
    }
    close IN;
  }else{
  }

if($debugFlag == 1){
  print "GetProfileString::value = [$value]<br>\n";
}

  return $value;
}

####################################################
### Check Data
###   Check data format and proper limitation
###
### CheckData($data, $flag)
###   $data : the target data
###   $flag : "URL"/"HOST"/"IP"/"PORT"/"FILE"
###   Return value : OK = 0 / NG = 1
####################################################
sub CheckData {
  my $data = $_[0];
  my $flag = $_[1];
  my $ret = 1;

if($debugFlag == 1){
  print "CheckData::data = [$data]<br>\n";
  print "CheckData::flag = [$flag]<br>\n";
}

  ### Check flag
  if($flag=~/^[A-Z]{2,4}$/){
    if($flag eq "URL"){
      #############################
      ### URL
      ### http://<NAME>
      ### 
      ### Allowed letters for <NAME> 
      ###   A-Z a-z 0-9 / - . ~
      ###
      ### <NAME> Minimum length = 1
      ### <NAME> Maximum length = 255 (+ Scheme 7)
      ###
      if($data=~/^http:\/\/[A-Za-z0-9\/\-.~]{1,255}$/) {
        if(&CheckNull($data)){
        }else{
          $ret = 0;
        }
      }else{
      }
    }elsif($flag eq "HOST"){
      #############################
      ### HOST
      ### <NAME>
      ### 
      ### Allowed letters for <NAME> 
      ###   A-Z a-z 0-9 - .
      ###
      ### <NAME> Minimum length = 1
      ### <NAME> Maximum length = 255 (Full domain name)
      ###
      if($data=~/^[A-Za-z0-9\-.]{1,255}$/) {
        if(&CheckNull($data)){
        }else{
          $ret = 0;
        }
      }else{
      }
    }elsif($flag eq "IP"){
      #############################
      ### IP
      ### <OCTET>.<OCTET>.<OCTET>.<OCTET>
      ### 
      ### Allowed letters for <OCTET> 
      ###   0-9
      ###
      ### Allowed range for <OCTET> 
      ###   0-255
      ###
      ### <OCTET> Minimum length = 1
      ### <OCTET> Maximum length = 3
      ###
      if($data=~/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/) {
        my @tmp = split(/\./, $data);
        if(($tmp[0] >= 0) && ($tmp[0] <= 255) && ($tmp[1] >= 0) && ($tmp[1] <= 255) && ($tmp[2] >= 0) && ($tmp[2] <= 255) && ($tmp[3] >= 0) && ($tmp[3] <= 255)){
          $ret = 0;
        }else{
        }
      }else{
      }
    }elsif($flag eq "PORT"){
      #############################
      ### PORT
      ### <NUMBER>
      ### 
      ### Allowed letters for <NUMBER> 
      ###   0-9
      ###
      ### Allowed range for <NUMBER> 
      ###   1-65535
      ###
      ### <NUMBER> Minimum length = 1
      ### <NUMBER> Maximum length = 255 (Full domain name)
      ###
      if($data=~/^[1-9][0-9]{0,4}$/) {
        if(($data >= 1) && ($data <= 65535)){
          $ret = 0;
        }else{
        }
      }else{
      }
    }elsif($flag eq "FILE"){
      #############################
      ### FILE
      ### $basedir/<NAME>
      ### 
      ### Allowed letters for <NAME> 
      ###   A-Z a-z 0-9
      ###
      ### <NAME> Minimum length = 1
      ### <NAME> Maximum length = 64
      ###
      if($data=~/^${basedir}\/[A-Za-z0-9]{1,64}$/) {
        $ret = 0;
      }else{
      }
    }else{
    }
  }else{
  }

if($debugFlag == 1){
  print "CheckData::ret = [$ret]<br>\n";
}
  return $ret;
}

####################################################
### Check Event
###   Check event format and get data
###
### CheckEvent($data, @pattern)
###   $data    : the target data
###   @pattern : message pattern
###   Return value : @ret[0] = Sub system number
###                  @ret[1] = project name
####################################################
sub CheckEvent {
  local($data, @pattern) = @_;
  my @ret = ("", "");

if($debugFlag == 1){
  print "CheckEvent::data = [$data]<br>\n";
  print "CheckEvent::pattern = [@pattern]<br>\n";
}

  #############################
  ### Target event pattern
  ###
  ### $pat1 = Systemwalker[<NUMBER1>]:
  ### $pat2 = <ID> MpJobsch<NUMBER2>:
  ### $pat3 = WARNING:
  ### $pat4 = <NUMBER3>:
  ### $pat5 = <PROJECT_NAME> <JOBNET_NAME> Messages
  ###
  ### Allowed letters for
  ###   <NUMBER1> 0-9
  ###   <NUMBER2> 1-9
  ###   <NUMBER3> 0-9
  ###   <ID> A-Z a-z 0-9 . [ ]
  ###   <PROJECT_NAME> A-Z a-z 0-9 + - _
  ###   <JOBNET_NAME>  A-Z a-z 0-9 + - _
  ###
  ### Allowed range for
  ###   <NUMBER1> 0-9999999999999999
  ###   <NUMBER2> 1-9 or empty
  ###   <NUMBER3> 0-9999999999999999
  ###
  ### <NUMBER1> Minimum length = 1
  ### <NUMBER1> Maximum length = 16
  ### <NUMBER2> Minimum length = 0
  ### <NUMBER2> Minimum length = 1
  ### <NUMBER3> Minimum length = 1
  ### <NUMBER3> Minimum length = 16
  ### <ID>      Minimum length = 0
  ### <ID>      Maximum length = 66
  ### <PROJECT_NAME> Maximum length = 1
  ### <PROJECT_NAME> Maximum length = 20
  ### <JOBNET_NAME>  Maximum length = 1
  ### <JOBNET_NAME>  Maximum length = 8
  ###
  my $pat1 = "Systemwalker\\[[0-9]{1,16}\\]:";
  my $pat2 = "[\\[]{0,1}[A-Za-z0-9_. ]{0,64}[\\]]{0,1} *MpJobsch([1-9]{0,1}):";
  my $pat3 = "WARNING:";
  my $pat4 = "[0-9]{1,16}:";
  my $pat5 = "([A-Za-z0-9+\\-_]{1,20}) +[A-Za-z0-9+\\-_]{1,8}";

### For Logger's event test
###
### $pat1 = user:
###
if($testFlag == 1){
  $pat1 = "[A-Za-z0-9]{1,64}:";
}

  if(length($data)>=2048){
    ### If over 2048, can not analyze it.
  }else{
    foreach $pat (@pattern){
      ### Check all patterns
      if($data=~/^${pat1} +${pat2} +${pat3} +${pat4} +${pat5} +${pat}$/){
        my $subSystemNumber = $1;
        my $projectName = $2;
        if(&CheckNull($data)){
        }else{
          ### Sub system number
          if(length($1)==0){
            ### If no number, set 0.
            $ret[0] = 0;
          }else{
            $ret[0] = $subSystemNumber;
          }
          ### Project name
          $ret[1] = $projectName;
        }
      }else{
      }
    }
  }

if($debugFlag == 1){
  print "CheckEvent::ret[0] = [$ret[0]]<br>\n";
  print "CheckEvent::ret[1] = [$ret[1]]<br>\n";
}

  return @ret;
}

####################################################
### Lock file
###   Make the lock file and wait for releasing it
###
### lock($lockfile)
###   $lockfile : the lock file
###   Return value : OK = 0 / NG = 1
####################################################
sub lock {
  my $lockfile = $_[0];
  my $count = 0;

if($debugFlag == 1){
  print "lock::lockfile = [$lockfile]<br>\n";
}

  if(-l $lockfile){
    ### If lock file is symbolic link, can not go..
    return 1;
  }
  while((-e $lockfile)){
    ### If lock file is exist, wait for releasing it for 60 sec.

if($debugFlag == 1){
  print "lock::[WAIT LOCK $count]<br>\n";
}

    sleep(2);
    $count += 2;
    if($count>=60){
      ### time out!
      return 1;
    }
  }

  ### Create the lock file
  my $ret = sysopen OUT,$lockfile,O_CREAT;
  if($ret eq undef){
  }else{
  }
  chmod 0600, $lockfile;

if($debugFlag == 1){
  print "lock::lockfile(sleep)<br>\n";
  sleep(10);
}

  return 0;
}

####################################################
### Unlock file
###   Delete the lock file
###
### unlock($lockfile)
###   $lockfile : the lock file
###   Return value : OK = 0 / NG = 1
####################################################
sub unlock {
  my $lockfile = $_[0];

if($debugFlag == 1){
  print "unlock::lockfile = [$lockfile]<br>\n";
}

if($debugFlag == 1){
  print "unlock::[STDIN]<br>\n";
  <STDIN>;
}

  ### delete the lock file
  unlink($lockfile);
  return 0;
}


####################################################
### Check Null
###   Check null letter (%00) in the data
###
### CheckNull($data)
###   $data    : the target data
###   Return value : OK = 0 / NG = 1
####################################################
sub CheckNull {
  my $data = $_[0];
  my $ret = 1;

if($debugFlag == 1){
  print "CheckNull::data = [$data]<br>\n";
}

  if($data=~/\%00/){
  }else{
    $ret = 0;
  }
  
if($debugFlag == 1){
  print "CheckNull::ret = [$ret]<br>\n";
}

  return $ret;
}


